(**-- FTree.pas ---------------------------------------------------2020------*
* Tree schedule demonstration program                                        *
* developed by Rik Smit on jan 2020,                                         *
* for Blaise Pascal Magazine Blaise_86_UK                                    *
**-------------------------------------------------------------------------**)

(*7--Code 7: The make4 code of the Lazarus Ftree program Blaise_86_UK-------*)

unit FTree;

{$mode objfpc}{$H+}

interface

uses
  windows, // because of using CloseHandle()
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  lazUTF8;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnMake4: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    procedure btnMake4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public
    FAppPath : String;   { field: Application Path }
  end;

var
  Form1: TForm1;

implementation

uses STDNODE, STDTREE;                       { the old 1993 DOS pascal units }

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnMake4Click(Sender: TObject);
Var tree : TTr;
    MyHandle: THandle;
    MyFile : String;
Begin
  MyFile := FAppPath+'Output\Print-Objecttree-LAZARUS.txt';
  if NOT FileExists(MyFile) then
  Begin
(* NOTE:
   function : fileCreate(const:filename: string): THandle
   Since 2010 its type is THandle (it was integer)!
*)
    MyHandle := FileCreate(MyFile,65001);
    Showmessage(MyFile+' is created');
(* NOTE:
   Close MyHandle here to avoid later a I/0 error 32: "Sharing violation":
   "that means that another process is using that file, and you can not save
   your changes until that process is done using the same file."
   This happens here when you try to rewrite this new created file with
   rewrite(LST)in this same procedure/program at the same time.
*)
   CloseHandle(MyHandle);
// of shorter: CloseHandle (FileCreate (MyFile));

// Now we can acces this file again in the same procedure
  End;

  assignFile(LST,(MyFile));
  with tree do
  begin
    try
      rewrite(LST);
      init;
      maketree(4);                     { claim extra memory for the pointers }
      form1.label2.Caption:= inttostr(CntNds);
      PrintTree;          { write to textfile LST and to Memo.lines.Append() }
    finally
      done;                                 { free the extra memory pointers }
      reset(Lst);
      readln(lst,myfile);
      label3.caption:= myfile;
      CloseFile(LST);
    end; { try }
  end; { with }
end; { procedure }

procedure TForm1.FormCreate(Sender: TObject);
begin
//Path by intern Lazarus/Delphi functions
  FAppPath := ExtractFilePath(Application.ExeName) ;
end;

end.
(*-------------------------------------------------------------------------7*)
